#include <system.h>

//RS232̃\tgG~[Vsꍇ́AdefineLɂiM̂݁j
#define _SOFT_EMULATION_
/*======================================================================
	Software Emulation Serial Output(Send Only)
	Speed=9600
	Parity=Non
	Bits=8
	StopBit=1
======================================================================*/


#ifdef _SOFT_EMULATION_
//Software Emulation
#define SENDPORT	portc
#define SENDBIT	6

#define bitdelay()	delay_us(104)	//delay for 9600 bps at 20MHz
//#define bitdelay()	delay_us(83)	//delay for 9600 bps	at 16MHz

void serialInit(char rateScaler)
{
	set_bit(SENDPORT,SENDBIT);
}

void serialSendChar(char value)
{
	char i;
	clear_bit(SENDPORT,SENDBIT);	//StartBit
	bitdelay();
	for(i=0;i<8;i++){
		if(value & 1)
			set_bit(SENDPORT,SENDBIT);
		else
			clear_bit(SENDPORT,SENDBIT);
		bitdelay();
		value>>=1;
	}
	set_bit(SENDPORT,SENDBIT);	//Stop Bit
	bitdelay();
}
#else
//Hardware SCI
void serialInit(char rateScaler)
{
	//baud rate init
    spbrg = rateScaler;

	//transmit init
	//txsta : Transmit Status and Control Register
	//bit7 : Clock Source Select bit (0 = Slave mode)
	//bit6 : 9-bit Transmit Enable bit (0 = Selects 8-bit transmission)
	//bit5 : Transmit Enable bit (1 = Enable)
	//bit4 : USART Mode Select bit (0 = Asynchronous mode)
	//bit3 : Send Break Character bit (0 = Sync Break transmission completed)
	//bit2 : High Baud Rate Setect bit (1 = High speed)
	//bit1 : Transmit Shift Register Status bit (0 = TSR full)
	//bit0 : 9bit mode only (Select 0)
    txsta = 00100100b;

	//receive init
	//rcsta : Receive Status and Control Register
	//bit7 : Serial Port Enable bit (1 = Enable)
	//bit6 : 9bit Receive Enable bit (0 = Select 8bit reception)
	//bit5 : Single Receive Enable bit (Async mode : don't care  Select 0)
	//bit4 : Continuous Receive Enable bit (1 = Enable)
	//bit3 : Address Detect Enable bit (0 = Disable address detection)
	//bit2 : Framing Error bit (0 = No framing error)
	//bit1 : Overrun Error bit (0 = No overrun error)
	//bit0 : 9bit mode only (Select 0)
    rcsta = 10010000b;	//Disable Recieve
}

void serialSendChar(char value)
{
    while((txsta & 1 << TRMT) == 0);                                 // TRMT is better then TXIF
    txreg = value;	//txreg = USART Transmit Register
}
#endif

char serialIsReceive()
{
	//return 0:No recive,othrer:recieved
    return 0;
}

char serialReceiveChar()
{
    return 0;
}

void serialSendString(const char* text)
{
    char i = 0;
    while(text[i] != 0)
        serialSendChar(text[i++]);
}

void serialSendDec(char n)
{
    if(n > 99)
        serialSendChar(((n / 100) % 10) + '0');
    if(n > 9)
        serialSendChar(((n / 10) % 10) + '0');
    serialSendChar((n % 10) + '0');
}

void serialSendHex(char n)
{
    char hexChar;
    char i;
    for(i = 0; i < 2; i++)
    {
        if(i == 0)
            hexChar = n >> 4;
        else
            hexChar = n & 0x0F;
        if(hexChar < 10)
            hexChar = hexChar + '0';
        else
            hexChar = hexChar + ('A' - 10);
        serialSendChar(hexChar);
    }
}

void serialSendBin(char n)
{
    char i;
    for(i = 0; i < 8; i++)
    {
        if(n & 10000000b)
                serialSendChar('1');
        else
                serialSendChar('0');
        n <<= 1;
    }
}


void serialSendShort(unsigned short n)
{
	char dat[2];
	char i;

	dat[0]=n>>8;
	dat[1]=n & 0xff;
	for(i=0;i<2;i++){
		serialSendHex(dat[i]);
	}	
}

void serialSendLong(unsigned long n)
{
	short dat[2];
	char i;

	dat[0]=n>>16;
	dat[1]=n & 0xffff;
	for(i=0;i<2;i++){
		serialSendShort(dat[i]);
	}	
}
